VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DISK READ/WRITE"
   ClientHeight    =   3390
   ClientLeft      =   7995
   ClientTop       =   5565
   ClientWidth     =   2550
   LinkTopic       =   "Form1"
   ScaleHeight     =   3390
   ScaleWidth      =   2550
   Begin VB.Frame Frame1 
      Caption         =   "Disk Read/Write"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3135
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2295
      Begin VB.CommandButton Command1 
         Caption         =   "Start"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   600
         TabIndex        =   7
         Top             =   2400
         Width           =   855
      End
      Begin VB.TextBox txtLUN 
         Height          =   285
         Left            =   1080
         TabIndex        =   6
         Top             =   1560
         Width           =   615
      End
      Begin VB.TextBox txtTarget 
         Height          =   285
         Left            =   1080
         TabIndex        =   5
         Top             =   1080
         Width           =   615
      End
      Begin VB.TextBox txtHA 
         Height          =   285
         Left            =   1080
         TabIndex        =   4
         Top             =   600
         Width           =   615
      End
      Begin VB.Label Label3 
         Caption         =   "LUN"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   1560
         Width           =   495
      End
      Begin VB.Label Label2 
         Caption         =   "Target"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   1080
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "HA"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   1
         Top             =   600
         Width           =   375
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()

Dim bytBufferData(100) As Byte
Dim bytDiskData(2048) As Byte
Dim bytSensedata(16) As Byte
Dim lngHighblock As Long
Dim lngBlocksize As Long
Dim lngCount As Long
Dim lngHa As Long
Dim lngTarget As Long
Dim lngLun As Long
Dim intRetVal As Integer
Dim intI As Integer
Dim intTestloop As Integer
Dim strResults As String
Dim strNL As String
Dim lngStartBlock As Long
Dim bytResults As Byte

strNL = Chr(10)

'********set the HA, Target, & lUN int the textboxes to match your configuration********

lngHa = txtHA.Text
lngTarget = txtTarget.Text
lngLun = txtLUN.Text
lngStartBlock = 0
lngCount = 4

'********If any textboxes are left blank...********

If txtHA.Text = "" Then

    MsgBox "You must select a HA."
    txtHA.SetFocus
    Exit Sub
    
ElseIf txtTarget.Text = "" Then

    MsgBox "You must select a target."
    txtTarget.SetFocus
    Exit Sub
    
ElseIf txtLUN.Text = "" Then

    MsgBox "You must select a LUN."
    Exit Sub
    
End If

For intI = 0 To 63      'fills our byte buffer array...

        bytBufferData(intI) = intI
        
Next

'********Sets the first 2k of buffer 0 to a pattern that increments from 0 to 64********
'********(This is the data put into bufferdata with the for loop above********

intRetVal = VBSCSIFillBuffer(0, 2048, 64, bytBufferData)

'********Writes 4 blocks of this data, starting at block 0********

intRetVal = VBSCSIDiskWrite(lngHa, lngTarget, lngLun, lngCount, lngStartBlock, 512, 0)

If intRetVal <> 0 Then

        strResults = "Disk Write failed - Status = " & intRetVal
        intRetVal = VBSCSIViewSense(bytSensedata)       'Displays sense data for troubleshooting...
        strResults = strResults & strNL & "Sense Key = " & Format(Hex(bytSensedata(2) And 15), "@@")
        strResults = strResults & strNL & "Sense Code = " & Format(Hex(bytSensedata(12)), "@@")
        strResults = strResults & strNL & "ASQ = " & Format(Hex(bytSensedata(13)), "@@")
        MsgBox strResults
        Stop
        
End If

'********Read 4 blocks of data into buffer 1********

intRetVal = VBSCSIDiskRead(lngHa, lngTarget, lngLun, lngCount, lngStartBlock, 512, 1)

If intRetVal <> 0 Then

        strResults = "Read command failed - Status = " & intRetVal
        intRetVal = VBSCSIViewSense(bytSensedata)   'Displays sense data for troubleshooting...
        strResults = strResults & strNL & "Sense Key = " & Format(Hex(bytSensedata(2) And 15), "@@")
        strResults = strResults & strNL & "Sense Code = " & Format(Hex(bytSensedata(12)), "@@")
        strResults = strResults & strNL & "ASQ = " & Format(Hex(bytSensedata(13)), "@@")
        MsgBox strResults
        Stop
        
End If


'********Move some data into the local buffer so we can print it********

intRetVal = VBSCSIGetBuffer(0, 128, bytDiskData)

'********Print 70 bytes so you can see the 64 byte pattern********

For intI = 0 To 70

    strResults = strResults & Format(Hex(bytDiskData(intI)), "@@") & " "
    
Next

'********Print the results in a messagebox********

MsgBox strResults

MsgBox "Test Passed"

End Sub



